#ifndef MATRICE_H
#define MATRICE_H

#include <iostream>
#include "rationnel.h"

using namespace std;

typedef unsigned short int usint;

class Matrice{
private:
  class Ligne;
  usint nb_lignes,nb_colonnes;
  float* coeffs;
public:
  explicit Matrice(usint nb_ligne);
  Matrice();
  Matrice(usint nb_ligne,usint nb_colonnes); 
  Matrice(const Matrice& M);
  ~Matrice();
  Matrice& operator=(const Matrice& M);
  usint get_nb_lignes() const;
  usint get_nb_colonnes() const;
  Ligne operator[](usint l); 
  const Ligne operator[](usint l) const;
  bool operator==(const Matrice& M) const;
  bool operator!=(const Matrice& M) const;
  Matrice operator+(const Matrice& B) const;
  Matrice operator-(const Matrice& B) const;
  Matrice operator*(const float& x) const;
  friend Matrice operator*(const float& x,const Matrice& B); 
  Matrice operator*(const Matrice& M) const;
  void ech_ligne(usint i,usint j);
  void mul_ligne(usint i,float c);
  void add_mul_ligne(usint i,usint j, float c);
  Matrice Gauss() const;
  usint rang() const;
  float determinant() const;
  bool est_inversible() const;
  Matrice inverse() const;
  friend ostream& operator<<(ostream& os,const Matrice& M);
};

class Matrice::Ligne{
 public:
  const Matrice* matrice;
  usint l;
  Ligne(const Matrice* M,usint l);
  float& operator[](usint c);
  float operator[](usint c) const;
};


#endif
