#include "spline.h"


ostream& operator<<(ostream& os,const Spline& S){
  os<<"Spline"<<endl;
  for(usint i=0;i<S.nb_points-1;i++){
    os<<"* ["<<S.x[i]<<","<<S.x[i+1]<<"] : "<<S.polynomes[i]<<endl;
  }
  return os;
}

void dessine_spline(Ecran_SDL ecran,Spline S,Couleur C){
  Point A,Ap;
  A.x=S.x[0];
  A.y=S.polynomes[0](A.x-S.x[0]);
  double xi;
  double x;
  for(usint i=0;i<S.nb_points-1;i++){
    xi=S.x[i];
    for(x=xi;x<=S.x[i+1];x++){
      Ap=A;
      A.x=x;
      A.y=S.polynomes[i](x-xi);
      ecran.dessine_segment(Ap,A,C);
    }
  }
};

void dessine_spline(Ecran_SDL ecran,SplineParametrique S,Couleur C){
  for(usint i=0;i<S.nb_points-1;i++){
    for(float t=0;t<1;t+=0.001){
      ecran.dessine_point(Point(S.poly_x[i](t),S.poly_y[i](t)),C);
    }
  }
}


Spline get_spline_lineaire(Point* P,usint n){
  Spline S;
  S.nb_points=n;
  S.x=new float[n];
  S.polynomes=new Polynome[n-1];
  S.x[0]=P[0].x;
  Polynome pi(1);
  for(usint i=0;i<n-1;i++){
    S.x[i+1]=P[i+1].x;
    pi[0]=P[i].y;
    pi[1]=P[i+1].y-P[i].y;
    pi[1]=pi[1]/(P[i+1].x-P[i].x);
    S.polynomes[i]=pi;
  }
  return S;
}



Spline get_spline_quadratique(Point* P,usint n, float p){
  Spline S;
  S.nb_points=n;
  S.x=new float[n];
  S.polynomes=new Polynome[n-1];
  S.x[0]=P[0].x;
  Polynome q(2);
  q[0]=P[0].y;
  q[1]=p;
  float h=P[1].x-P[0].x;
  q[2]=(P[1].y-P[0].y)-p*h;
  q[2]=q[2]/(h*h);
  S.polynomes[0]=q;
  Polynome qp=q;
  S.x[1]=P[1].x;
  for(usint i=1;i<=n-2;i++){
    S.x[i+1]=P[i+1].x;
    q[0]=P[i].y;
    h=P[i+1].x-P[i].x;
    q[1]=2*qp[2]*(P[i].x-P[i-1].x)+qp[1];
    q[2]=(P[i+1].y-P[i].y)-q[1]*h;
    q[2]=q[2]/(h*h);
    S.polynomes[i]=q;
    qp=q;
  }
  return S;
}

Spline get_spline_cubique(Point* P,usint n, float p1, float p2){
  Spline S;
  S.nb_points=n;
  S.x=new float[n];
  S.polynomes=new Polynome[n-1];
  S.x[0]=P[0].x;
  Polynome q(3);
  q[0]=P[0].y;
  q[1]=p1;
  q[2]=p2/2;
  float h=P[1].x-P[0].x;
  float hp;
  q[3]=(P[1].y-P[0].y)-q[2]*h*h-q[1]*h;
  q[3]=q[3]/(h*h*h);
  S.polynomes[0]=q;
  Polynome qp=q;
  S.x[1]=P[1].x;
  for(usint i=1;i<=n-2;i++){
    S.x[i+1]=P[i+1].x;
    q[0]=P[i].y;
    h=P[i+1].x-P[i].x;
    hp=P[i].x-P[i-1].x;
    q[1]=3*qp[3]*hp*hp+2*qp[2]*hp+qp[1];
    q[2]=3*qp[3]*hp+qp[2];
    q[3]=(P[i+1].y-P[i].y)-q[2]*h*h-q[1]*h;
    q[3]=q[3]/(h*h*h);
    S.polynomes[i]=q;
    qp=q;
  }
  return S;
}




Spline get_spline_quadratique2(Point* P,usint n,float pente){
  Spline S;
  S.nb_points=n;
  S.x=new float[n];
  S.polynomes=new Polynome[n-1];
  S.x[0]=P[0].x;
  S.x[1]=P[1].x;
  Polynome pi(2);
  pi[0]=P[0].y;
  pi[1]=pente;
  pi[2]=(P[1].y-P[0].y)-pente*(P[1].x-P[0].x);
  pi[2]=pi[2]/((P[1].x-P[0].x)*(P[1].x-P[0].x));
  S.polynomes[0]=pi;
  for(usint i=1;i<n-1;i++){
    S.x[i+1]=P[i+1].x;
    pi[0]=P[i].y;
    pi[1]=2*S.polynomes[i-1][2]*(P[i].x-P[i-1].x)+S.polynomes[i-1][1];
    pi[2]=(P[i+1].y-P[i].y)-pi[1]*(P[i+1].x-P[i].x);
    pi[2]=pi[2]/((P[i+1].x-P[i].x)*(P[i+1].x-P[i].x));
    S.polynomes[i]=pi;
  }
  return S;
}

Spline get_spline_cubique(Point* P,usint n,Matrice M){
  Spline S;
  S.nb_points=n;
  S.x=new float[n];
  S.polynomes=new Polynome[n-1];
  for(usint i=0;i<n;i++){
    S.x[i]=P[i].x;
  }
  Polynome q(3);
  float h,m,mn;
  float a,b,c,d;
  for(usint i=0;i<n-1;i++){
    d=P[i].y;
    h=P[i+1].x-P[i].x;
    m=M[i+1][1];
    mn=M[i+2][1];
    c=(P[i+1].y-P[i].y)/h-h*(mn-m)/6-h*m/2;
    b=m/2;
    a=(mn-m)/(6*h);
    q[3]=a;
    q[2]=b;
    q[1]=c;
    q[0]=d;
    cout<<a<<","<<b<<","<<c<<","<<d<<endl;
    S.polynomes[i]=q;
  }
  return S;
}

Spline get_spline_cubique_naturelle(Point* P,usint n){
  float h,hp;
  float t,tp;
  Matrice A(n,n);
  Matrice B(n,1);
  A[1][1]=1;
  B[1][1]=0;
  A[n][n]=1;
  B[n][1]=0;
  hp=P[1].x-P[0].x;
  h=P[2].x-P[1].x;
  tp=P[1].y-P[0].y;
  tp=tp/hp;
  t=P[2].y-P[1].y;
  t=t/h;
  for(usint i=2;i<=n-1;i++){
    A[i][i-1]=hp;
    A[i][i]=2*(hp+h);
    A[i][i+1]=h;
    B[i][1]=6*(t-tp);
    hp=h;
    h=P[i+1].x-P[i].x;
    tp=t;
    t=P[i+1].y-P[i].y;
    t=t/h;
  }
  cout<<"A="<<A<<endl;
  cout<<"B="<<B<<endl;

  Matrice AI=A.inverse();
  Matrice M=AI*B;
  cout<<"M="<<M<<endl;
  cout<<"B="<<A*M<<endl;
  //return S;
  return get_spline_cubique(P,n,M);
}

SplineParametrique get_spline_cubique_parametrique(Point* P,usint n,Matrice Mx,Matrice My){
  SplineParametrique S;
  S.nb_points=n;
  S.poly_x=new Polynome[n-1];
  S.poly_y=new Polynome[n-1];
  Polynome q(3);
  for(usint i=0;i<n-1;i++){
    q[3]=(Mx[i+2][1]-Mx[i+1][1])/6;
    q[2]=Mx[i+1][1]/2;
    q[1]=P[i+1].x-P[i].x-q[3]-q[2];
    q[0]=P[i].x;
    S.poly_x[i]=q;
    q[3]=(My[i+2][1]-My[i+1][1])/6;
    q[2]=My[i+1][1]/2;
    q[1]=P[i+1].y-P[i].y-q[3]-q[2];
    q[0]=P[i].y;
    S.poly_y[i]=q;
  }
  return S;
}

SplineParametrique get_spline_cubique_parametrique_naturelle(Point* P,usint n){
  Matrice A(n,n);
  Matrice Bx(n,1);
  Matrice By(n,1);
  A[1][1]=1;
  A[n][n]=1;
  Bx[1][1]=0;
  Bx[n][1]=0;
  By[1][1]=0;
  By[n][1]=0;
  for(usint i=2;i<=n-1;i++){
    A[i][i-1]=1;
    A[i][i]=4;
    A[i][i+1]=1;
    Bx[i][1]=6*(P[i].x-2*P[i-1].x+P[i-2].x);
    By[i][1]=6*(P[i].y-2*P[i-1].y+P[i-2].y);
  }
  //cout<<"A="<<A<<endl;
  //cout<<"Bx="<<Bx<<endl;
  //cout<<"By="<<By<<endl;
  Matrice AI=A.inverse();
  Matrice Mx=AI*Bx;
  Matrice My=AI*By;
  return get_spline_cubique_parametrique(P,n,Mx,My);
}

SplineParametrique get_spline_cubique_parametrique_periodique(Point* P,usint n){
  Matrice A(n,n);
  Matrice Bx(n,1);
  Matrice By(n,1);
  A[1][1]=1;
  A[1][n]=-1;
  A[n][1]=2;
  A[n][2]=1;
  A[n][n-1]=1;
  A[n][n]=2;
  Bx[1][1]=0;
  Bx[n][1]=6*(P[1].x-P[0].x+P[n-2].x-P[n-1].x);
  By[1][1]=0;
  By[n][1]=6*(P[1].y-P[0].y+P[n-2].y-P[n-1].y);
  for(usint i=2;i<=n-1;i++){
    A[i][i-1]=1;
    A[i][i]=4;
    A[i][i+1]=1;
    Bx[i][1]=6*(P[i].x-2*P[i-1].x+P[i-2].x);
    By[i][1]=6*(P[i].y-2*P[i-1].y+P[i-2].y);
  }
  //cout<<"A="<<A<<endl;
  //cout<<"Bx="<<Bx<<endl;
  //cout<<"By="<<By<<endl;
  Matrice AI=A.inverse();
  Matrice Mx=AI*Bx;
  Matrice My=AI*By;
  return get_spline_cubique_parametrique(P,n,Mx,My);
}
