#ifndef SPLINE_H
#define SPLINE_H

#include "lib.h"
#include "polynome.h"
#include "matrice.h"

struct Spline{
  usint nb_points;//nombre de points
  float* x;
  Polynome* polynomes;
};

struct SplineParametrique{
  usint nb_points;
  Polynome* poly_x;
  Polynome* poly_y;
};

ostream& operator<<(ostream& os,const Spline& S);

void dessine_spline(Ecran_SDL ecran, Spline S,Couleur c);
void dessine_spline(Ecran_SDL ecran, SplineParametrique S,Couleur c);

Spline get_spline_lineaire(Point* P,usint n);
Spline get_spline_quadratique(Point* P,usint n,float pente);
Spline get_spline_cubique(Point* P,usint n,float p1,float p2);
Spline get_spline_cubique_naturelle(Point* P,usint n);
Spline get_spline_cubique(Point* P,usint n,Matrice M);
SplineParametrique get_spline_cubique_parametrique(Point* P,usint n,Matrice Mx,Matrice My);
SplineParametrique get_spline_cubique_parametrique_naturelle(Point* P,usint n);
SplineParametrique get_spline_cubique_parametrique_periodique(Point* P,usint n);

#endif
